//class MyThread extends Threads...
//////////////////////////////////////////////////////////////////////////
class Threads extends Thread {
  Complex zNeu,zAlt,zStart,C,c,z0,D, zNeuN,zAltN,zTemp;
  ArrayList<Complex> Fixpunkte;
  int AnzahlFixpunkte;
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int anzahlItNewton;
  int tN;
  int selektor;
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;
  int zaehlen;
  int trapFaktor;
  int helligkeit;
  double aQMax =0;
  int farbIndex =0;
  int farbNummer =0;
  double laenge,abstand;
  double x0,y0 ;
  double x,y ;
  double r,R,rM;
  double d;
  boolean trapped;
  boolean sinusXAchse = false;
  boolean sinusYAchse = false;
  boolean getroffen = false;
  double mR,mI;
  Complex [] MP;
  int j,k;
  int indexFP;
  double epsilon ;
  double trapAbstandX;
  double trapAbstandY;
  double nZwischen;
  double minAbstandZumFP;
  double d1,d2;
  double DistanzZuFP,DistanzTemp;
  float fxMin, fxMax, fyMin, fyMax;
  String s;

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, 
                 int nummer, double X0, double Y0, int Selektor, double e, float FxMin, 
                 float FxMax, float FyMin, float FyMax, ArrayList<Complex> fixpunkte) {
    // benötigte Parameter
    epsilon =e;
    Fixpunkte = fixpunkte;
    AnzahlFixpunkte = fixpunkte.size();
    selektor = Selektor;
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    x0 = X0; y0 = Y0;
    fxMin = FxMin; fxMax = FxMax;
    fyMin = FyMin; fyMax = FyMax;
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    anzahlItNewton = 20; //Anzahl der Iterationschritte für das Konvergenz-Geschwindigkeitsbild
    colorMode(HSB,256,256,256);
    C = new Complex(X0,Y0);
    pg = createGraphics(width,height/anzahlThreads);
    r=0.16;//Radius der 8 Kreise außen  
    MP = new Complex [anzahlFixpunkte];
    for (int i =0; i<anzahlFixpunkte; i++){
      MP[i] = new Complex(Fixpunkte.get(i));
    }
    trapAbstandX = 0.05;//für kleineren trapAbstand trapFaktor größer wählen: zB. 0.01 und 5000
    trapAbstandY = 0.05;
    trapFaktor = 5000; 
       
  }
////////////////////////////////////////////////////////////////////  
  public int gibNummer(){   
    return tN;   
  }

 //////////////////////////////////////////////////////////////
public void run() {
    
  switch(selektor){
    case 1: 
      bild1();
      break;
    case 2:
      bild2();
      break;
    case 3:
      bild3();
      break;
    case 4:
      bild4();
      break;
    case 5:
      bild5();
      break;
    case 6:
      bild6();
      break;   
  }
   
 }
///////////////////////////////////////////////////////////////////
color newtonJuliaKonvergenz(Complex Z0){//Fatou-Bereiche werden nur bzg. Konvergenzgeschwindigkeit gefärbt
    color rueckgabe = color(0);
    int n = 0;
    zAlt = Z0;
    while(n < anzahlItNewton  ){
    zNeu = FPNewton10(zAlt); 
    if((zNeu.subtractC(zAlt)).getLength() < 1e-20){      
         break;
      }
      zAlt = zNeu;
      n++;
    }    
    rueckgabe = color(140,255,5*n*n);
    return rueckgabe;
}
///////////////////////////////////////////////////////////////////
color newtonJuliaTrap(Complex Z0){//Bestimmung der Farbe (bzw. des Fatou-Bereichs)
    color rueckgabe = color(0);
    int n = 0;
    trapped = false;
    zAlt = Z0;
    zStart = Z0;
   
    //while-Schleife---------------------------------------------------------------------
    while(n < maxiterations  ){
    
      zNeu = FPNewton(zAlt); 
      abstand =(zNeu.subtractC(zAlt)).getLength();
      laenge = zNeu.getLength();
      x= Math.abs(zNeu.getRealPart());
      y =Math.abs(zNeu.getImaginaryPart());
      
      //sinusXAchsen-Trap
      if (Math.abs(sinusX(x)-y)< trapAbstandY){//im x-Achsen Sinus Bereich gefangen  (erste Präferenz) 
        a = Math.abs((float)sinusX(x)-y);
        sinusXAchse = true;
        n = (int)(trapFaktor*a);
        farbIndex = n % 1024;
        farbe = farben.farbenTrapZufall1024[0][farbIndex];  
        rueckgabe = farbe;
        break;      
      }
     //sinusYAchsen-Trap
     if (Math.abs(sinusY(y)-x)< trapAbstandX ){//im y-Achsen Sinus Bereich gefangen   
      a = Math.abs((float)sinusY(y)-x);
      sinusYAchse = true;
      n = (int)(trapFaktor*a);
      farbIndex = n % 1024;
      rueckgabe = farben.farbenTrapZufall1024[1][farbIndex];  
      break;      
     } 
    
    //senkrechte Achsen
     d = Math.abs(x);
     if(d<trapAbstandY){
       n = (int)(trapFaktor*d);  
       farbIndex = n % 1024;
       rueckgabe = farben.farbenTrapZufall1024[2][farbIndex];
       break;
     }
     
     //waagrechte Achse;
     d = Math.abs(y);
     if(d<trapAbstandX){
       n = (int)(trapFaktor*d);  
       farbIndex = n % 1024;
       rueckgabe = farben.farbenTrapZufall1024[3][farbIndex];
       break;
    }
    
     //Kreise um die Fixpunkte    
      for(int i =0; i<anzahlFixpunkte;i++){
      d = (Fixpunkte.get(i).subtractC(zNeu)).getLength();//if(d >0 && i==0)println(d,Fixpunkte.get(i),zNeu+" ");
        if(d<r){
          indexFP = i;         
          break;
        }      
      }     
      d = (Fixpunkte.get(indexFP).subtractC(zStart)).getLength();//if(d >0 && i==0)println(d,Fixpunkte.get(i),zNeu+" ");
      if(d<r){
        farbIndex = (int)(1200*d) % 1024;
        //if(i==0 && d>0.2)println(d,farbIndex+" ");
        rueckgabe = farben.farbenTrapZufall1024[indexFP+4][farbIndex];
        break;
      }      
 
   
    if(selektor ==4){
      rueckgabe = color(0);//Fatougebiete schwarz          
      if(abstand < 1e-10) break;
    }
    else if(abstand <1e-10){ //dann im Fatougebiet     
       k = 20;
       DistanzZuFP =10; 
       for(int i=AnzahlFixpunkte-1; i>=0;i--){        
         zTemp= Fixpunkte.get(i);
         DistanzTemp=zNeu.subtractC(zTemp).getLength();//if(tN==3)print(DistanzTemp+"  ");
         if(DistanzTemp < DistanzZuFP){//if(tN==3)print(DistanzTemp,DistanzZuFP+"  ");
            DistanzZuFP = DistanzTemp;
            k =i;  //if(tN==3)print(k,DistanzZuFP+"  ");
         } 
         if(i==0){
           minAbstandZumFP = zStart.subtractC(zNeu).getLength(); //if(tN==3)print(k,minAbstandZumFP+"  ");
         }
       }     
       helligkeit =(int) (80*minAbstandZumFP); //if(tN==3)print(helligkeit+"  ");
       if(helligkeit < 0) helligkeit =0;
       if(helligkeit > 255) helligkeit = 255;
       float H = (float)zNeu.getAngle();//funktioniert nur dann gut,
       H = H*360/(2.7*PI);              //wenn die Winkel verschieden sind
       rueckgabe = color(H,255,255-helligkeit); //   if(tN==3)print(255-helligkeit+"  ");
       break; 
    }   
    zAlt = zNeu; 
    n++;
    }
 //end of while---------------------------------------------------------------------  
   return rueckgabe;
}
///////////////////////////////////////////////////////////////////
color newtonJulia(Complex Z0){//Bestimmung der Farbe (bzw. des Fatou-Bereichs)
    color rueckgabe = color(0);
    int n = 0;
    trapped = false;
    zAlt = Z0;
  
    //while-Schleife---------------------------------------------------------------------
    while(n < maxiterations  ){
    
      zNeu = FPNewton(zAlt); 
      abstand =(zNeu.subtractC(zAlt)).getLength();
      laenge = zNeu.getLength();
      if(abstand <1e-10){       
         float H = (float)zNeu.getAngle();//funktioniert nur dann gut,
         H = H*360/(2.7*PI);              //wenn die Winkel verschieden sind
         rueckgabe = color(H,255,255);    
         break; 
      }   
      zAlt = zNeu; 
      n++;
    }
 //end of while---------------------------------------------------------------------  
   return rueckgabe;
}
/////////////////////////////////////////////////////////////////////
 Complex FPNewton10(Complex zAlt){//Newton-Iteration zehn mal
 
   for(int i =0; i< 10;i++){
      zNeu = f(zAlt,C).divide(fS(zAlt));
      zNeu = zAlt.addC(zNeu);
      zAlt = zNeu;
   }
  return zAlt;
 }
////////////////////////////////////////////////////////////////////////////////// 
 Complex FPNewton(Complex zAlt){//Newton-Iteration ein mal 
  
      zNeu = f(zAlt,C).divide(fS(zAlt));
      zNeu = zAlt.addC(zNeu);
      zAlt = zNeu;
 
  return zAlt;
 }
///////////////////////////////////////////////////////////////////////////////
  Complex f(Complex zAlt,Complex C){    //Zähler Newton-Iteration
      
      Complex zaehler = new Complex(0,0);
      zaehler = zAlt.power(11);//z^11
      zaehler = zaehler.addC((zAlt.power(4)).multiply(5));//z^11+5z^4-3z^3
      zaehler = zaehler.addC((zAlt.power(3)).multiply(-3));//z^11+5z^4-3z^3
      zaehler = zaehler.addC(C);//z^11+5z^4-3z^3+c 
      zaehler = zaehler.multiply(-1);
      return zaehler;
 }
 Complex fS(Complex zAlt){               //Nenner Newton-Iteration
      Complex nenner = new Complex(0,0);
      nenner = (zAlt.power(10)).multiply(11);//11z^10
      nenner = nenner.addC((zAlt.power(3)).multiply(20));//11z^10+20z^3
      nenner = nenner.addC((zAlt.power(2)).multiply(-9));//11z^10+20z^3-9z^2
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }
/////////////////////////////////////////////////////////////////////
color juliaQuadratTest(Complex Z0, double Dx, double Dy) {
   
    color rueckgabe ;
    
    int fpNummer0 =-1;
    float d = 10;
    int anzahlFP = Fixpunkte.size();
    int n = 0;  
    zAlt = Z0;
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;
        n++;
    }  
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer0 = i;
    } 
    
//--------------------------------------------------    
    int fpNummer1 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart());
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;
        n++;
    }    
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer1 = i;
    } 
//---------------------------------------------------    
    int fpNummer2 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart(),Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;        
        n++;
    }
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer2 = i;
    } 
    
//---------------------------------------------------------   
    int fpNummer3 =-1; 
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
        zNeu = FPNewton(zAlt);  
        zAlt = zNeu;      
        n++;
    }
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer3 = i;
    } 
        
   //Rückgabe weiß, wenn höchstens zwei Ecken des Quadrats zum gleichen FP führen
    if(fpNummer0==fpNummer1 && fpNummer1==fpNummer2  ||
       fpNummer0==fpNummer2 && fpNummer2==fpNummer3  ||
       fpNummer0==fpNummer1 && fpNummer1==fpNummer3  ||
       fpNummer1==fpNummer2 && fpNummer2==fpNummer3    ) 
       rueckgabe = color(0);//Pixel weiß: ein, zwei Eckpunkte im Chaos
       else rueckgabe = color(255);                            // d.h. drei oder zwei Eckpunkte im Konvergenzbereich
    
    return rueckgabe;
    
 
 }
////////////////////////////////////////////////////////////////////////////////////
void bild1(){
  tN =this.gibNummer();
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        double ymax = ymin + wh;
            
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) { 
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJulia(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild2(){
  tN =this.gibNummer();
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;       
        double ymax = ymin + wh;
             
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
            
             if(juliaQuadratTest(z0,dx,dy)==color(255)){//Punkt nahe der Julia-Menge
               pg.pixels[i+j*pg.width] = color(0);
             }else{
               pg.pixels[i+j*pg.width] = newtonJulia(z0);   
             }
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild3(){
  tN =this.gibNummer(); 
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;   
        double ymax = ymin + wh;
            
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) { 
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJuliaTrap(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild4(){
  tN =this.gibNummer(); 
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;      
        double ymax = ymin + wh;
              
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          double x = xmin;
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJuliaTrap(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild5(){
  tN =this.gibNummer(); 
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;       
        double ymax = ymin + wh;       
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             if(juliaQuadratTest(z0,dx,dy)==color(255)){
                pg.pixels[i+j*pg.width] = color(255);//Julia-Fraktal
                
              }else{
                 pg.pixels[i+j*pg.width] = color(0);//Nur Julia-Fraktal sichtbar
              }
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////
void bild6(){
  tN =this.gibNummer(); 
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;        
        double ymax = ymin + wh;
            
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) { 
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = newtonJuliaKonvergenz(z0);
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
 /////////////////////////////////////////////////////////////////////////
 double sinusX(double xWert){
   double yWert=0;
   yWert =1.2*Math.sin(PI*xWert);   
   return yWert; 
 }
///////////////////////////////////////////////////////////////////
 double sinusY(double yWert){
   double xWert=0;
   xWert = 1.2*Math.sin(PI*yWert);   //auch andere Parameter denkbar
   return xWert; 
 }
////////////////////////////////////////////////////////////////////

}
